<ion-app>
  <ion-content class="ion-padding eh-p-2" *ngIf="dispatchView else dataAwaitedBlk">
    <ng-container [formGroup]="weightFG">
      <div class="e-card2 e-card2--bg-eblue100 eh-mt-8 eh-p-4">
        <div class="e-card2__item eh-p-8">
          <div class="eh-txt-12 eh-txt-bold">Summary</div>
          <div class="eh-mt-4" fxLayout="row">
            <div class="eh-txt-12">
              <span>Start:</span>
              <span class="eh-ml-8 eh-txt-bold">{{ startWeightFC.value ? startWeightFC.value + ' kg' : '-' }}</span>
            </div>
            <div class="eh-txt-12 eh-ml-16">
              <span>Latest:</span>
              <span class="eh-ml-8 eh-txt-bold">{{ latestWeight ? latestWeight + ' kg' : '-' }}</span>
            </div>
            <div class="eh-txt-12 eh-ml-16">
              <span>Total Difference:</span>
              <span class="eh-ml-8 eh-txt-bold">
                {{ computeWeightDifference(latestWeight, startWeightFC.value, true) }}
              </span>
            </div>
          </div>
        </div>
      </div>

      <div class="e-title e-title--1 eh-mt-24">
        <mat-icon class="e-mat-icon e-mat-icon--3 eh-mr-8">monitor_weight</mat-icon>
        <span>Weight Parameters</span>
      </div>

      <div class="eh-mt-16" fxLayout="row" fxLayoutAlign="end">
        <div *ngIf="hasWeightFGChanged" class="e-txt e-txt--matred600 eh-mr-16" fxLayout="row"
          fxLayoutAlign="start center">
          <mat-icon class="e-mat-icon e-mat-icon--3">warning</mat-icon>
          <span class="eh-txt-12 eh-ml-4 eh-txt-bold">Unsaved changes</span>
        </div>

        <app-button-icon-title [title]="'Reset'" [buttonStyle]="'e-txt e-txt--matred600'"
          [icon]="'settings_backup_restore'" [disabled]="loading" (onButtonClick)="onReset()"></app-button-icon-title>

        <app-button-icon-title class="eh-ml-16 eh-mr-4" [title]="'Save'" [buttonStyle]="'e-txt e-txt--matgreen500'"
          [icon]="'save'" [loading]="loading" (onButtonClick)="onSave()"></app-button-icon-title>
      </div>

      <div class="eh-mt-12" fxLayout="row" fxLayoutAlign="start center">
        <div fxLayout="column" fxFlex="0 0 40%">
          <div fxLayout="row" fxLayoutAlign="start center">
            <div class="eh-w-100">
              Start Weight
            </div>

            <mat-form-field class="e-mat-form-field eh-w-100">
              <input matInput formControlName="startWeight" type="number">
            </mat-form-field>

            <div class="eh-ml-4">kg</div>
          </div>

          <div fxLayout="row" fxLayoutAlign="start center">
            <div class="eh-w-100">
              Start Date
            </div>

            <mat-form-field appearance="standard" class="e-mat-form-field eh-w-132">
              <input matInput [matDatepicker]="picker1" formControlName="startDate" readonly>
              <mat-datepicker-toggle class="e-mat-datepicker" matSuffix [for]="picker1"></mat-datepicker-toggle>
              <mat-datepicker #picker1></mat-datepicker>
            </mat-form-field>
          </div>
        </div>

        <div fxLayout="column" fxFlex="0 0 30%">
          <div fxLayout="row" fxLayoutAlign="start center">
            <div class="eh-w-100">
              Target Weight
            </div>

            <mat-form-field class="e-mat-form-field eh-w-100">
              <input matInput formControlName="targetWeight" type="number">
            </mat-form-field>

            <div class="eh-ml-4">kg</div>
          </div>

          <div fxLayout="row" fxLayoutAlign="start center">
            <div class="eh-w-100">
              Target Date
            </div>

            <mat-form-field appearance="standard" class="e-mat-form-field eh-w-132">
              <input matInput [matDatepicker]="picker2" formControlName="targetDate" readonly>
              <mat-datepicker-toggle class="e-mat-datepicker" matSuffix [for]="picker2"></mat-datepicker-toggle>
              <mat-datepicker #picker2></mat-datepicker>
            </mat-form-field>
          </div>
        </div>
      </div>

      <div class="eh-txt-12 eh-mt-12 eh-txt-italic">
        Please enter your weight in the table (in the morning, after toilet, before breakfast - without clothes)
      </div>

      <div class="e-brd e-brd--bottom eh-p-12 eh-mt-8" fxLayout="row">
        <div class="eh-txt-12" fxFlex="0 0 25%">Date</div>
        <div class="eh-txt-12" fxFlex="0 0 25%">Weight (kg)</div>
        <div class="eh-txt-12" fxFlex="0 0 25%">Total Loss/Gain (kg)</div>
        <app-button-icon-title fxFlex="0 0 25%" [title]="'Add row'" [buttonStyle]="'e-txt e-txt--eblue700'"
          [icon]="'playlist_add'" [iconStyle]="'e-mat-icon--2'" (onButtonClick)="addLog()"></app-button-icon-title>
      </div>

      <ng-container formArrayName="logs">
        <div *ngFor="let log of logsFA.controls; let i = index;" class="e-brd e-brd--bottom eh-px-12"
          [formGroupName]="i" fxLayout="row" fxLayoutAlign="start center">

          <div fxFlex="0 0 25%">
            <mat-form-field class="e-mat-form-field" appearance="standard">
              <input matInput [matDatepicker]="picker3" [max]="maxDate" formControlName="date"
                [matDatepickerFilter]="dateFilter" readonly>
              <mat-datepicker-toggle class="e-mat-datepicker" matSuffix [for]="picker3"></mat-datepicker-toggle>
              <mat-datepicker #picker3></mat-datepicker>
            </mat-form-field>
          </div>
          <div fxFlex="0 0 25%">
            <input class="e-bg e-bg--eblue200 eh-p-4" type="number" formControlName="weight">
          </div>
          <div fxFlex="0 0 25%">
            {{ computeWeightDifference(log.get('weight').value, startWeightFC.value) }}
          </div>
          <div>
            <app-button-icon [icon]="'delete'" (onButtonClick)="removeLog(i)"></app-button-icon>
          </div>
        </div>
      </ng-container>
    </ng-container>


  </ion-content>
  <ng-template #dataAwaitedBlk>
    <div class="e-spinner e-spinner--center eh-h-100v eh-h-100v">
      <mat-spinner [diameter]="30" [strokeWidth]="3"></mat-spinner>
    </div>
  </ng-template>
</ion-app>